<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<HTML>
<HEAD>
<Title> Tango Device Server User's Guide </Title>
</HEAD>
<BODY TEXT="#000000" BGCOLOR="#FFFFFF" LINK="#0000FF" VLINK="#7F00FF" ALINK="#FF0000">

<P><!-------TITLE------></P>

<TABLE BORDER="0" WIDTH="100%">
    <TR>
        <TD ALIGN="left">
			<A HREF="http://www.esrf.fr/" TARGET=new>
			<IMG SRC="http://controle/icons/esrf_logo.gif" BORDER=0></A>
		</Td>
        <TD ALIGN="center">
			<A HREF="http://www.elettra.trieste.it/" TARGET=new>
			<IMG SRC="http://controle/icons/elettra_logo.gif" BORDER=0></A>

		</Td>
        <TD ALIGN="center">
			<A HREF="http://www.synchrotron-soleil.fr/" TARGET=new>
			<IMG SRC="http://controle/icons/soleil_logo.gif" BORDER=0></A>
		</Td>
        <TD ALIGN="right">
			<A HREF="http://www.cells.es/" TARGET=new>
			<IMG SRC="http://controle/icons/alba_logo.gif" BORDER=0></A>
		</Td>
    	 <Td>
			<H2><FONT COLOR="#7F00FF">
			<Center><A HREF="http://www.esrf.fr/Infrastructure/Computing/tango/" TARGET="_top">
					 TANGO </a> <Br> Device Server
			</Center></FONT>
    	</Td>
    </TR>
</TABLE>

<HR WIDTH="100%"></H5>
<Br>
<center>
<h1>
TANGO Device Server for testing generic clients		<Br>
Device Attributes Description 		<Br> <Br>
TangoTest Class	<Br>
</h1>
<b>
Revision:  - Author: nleclercq
</b>
</center>


<Br>
<Table Border=2 Cellpadding=3 CELLSPACING=0 WIDTH="100%">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<Td COLSPAN=5> <Font Size=+2><Center><b>Scalar Attributes</b></td></Font></Center>
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<Td><Center><b>Attribute name</b></td></Center>
<Td><Center><b>Data Type</b></td></Center>
<Td><Center><b>R/W Type</b></td></Center>
<Td><Center><b>Ass. Attr.</b></td></Center>
<Td><Center><b>Expert</b></td></Center>
<Font Size=-1>
<Tr><Td><b>short_scalar_ro</b></Td>
<Td><Center><Font Size=-1>DEV_SHORT</Font></Center></Td><Td><Center><Font Size=-1>READ</Font></Center></Td><Td><Center> - </Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Font Size=-1>
<Tr><Td><b>short_scalar</b></Td>
<Td><Center><Font Size=-1>DEV_SHORT</Font></Center></Td><Td><Center><Font Size=-1>READ_WRITE</Font></Center></Td><Td><Center> - </Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Font Size=-1>
<Tr><Td><b>short_scalar_w</b></Td>
<Td><Center><Font Size=-1>DEV_SHORT</Font></Center></Td><Td><Center><Font Size=-1>WRITE</Font></Center></Td><Td><Center> - </Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Font Size=-1>
<Tr><Td><b>short_scalar_rww</b></Td>
<Td><Center><Font Size=-1>DEV_SHORT</Font></Center></Td><Td><Center><Font Size=-1>READ_WITH_WRITE</Font></Center></Td><Td><Center><Font Size=-1>short_scalar_w</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Font Size=-1>
<Tr><Td><b>long_scalar</b></Td>
<Td><Center><Font Size=-1>DEV_LONG</Font></Center></Td><Td><Center><Font Size=-1>READ_WRITE</Font></Center></Td><Td><Center> - </Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Font Size=-1>
<Tr><Td><b>long_scalar_w</b></Td>
<Td><Center><Font Size=-1>DEV_LONG</Font></Center></Td><Td><Center><Font Size=-1>WRITE</Font></Center></Td><Td><Center> - </Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Font Size=-1>
<Tr><Td><b>long_scalar_rww</b></Td>
<Td><Center><Font Size=-1>DEV_LONG</Font></Center></Td><Td><Center><Font Size=-1>READ_WITH_WRITE</Font></Center></Td><Td><Center><Font Size=-1>long_scalar_w</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Font Size=-1>
<Tr><Td><b>double_scalar</b></Td>
<Td><Center><Font Size=-1>DEV_DOUBLE</Font></Center></Td><Td><Center><Font Size=-1>READ_WRITE</Font></Center></Td><Td><Center> - </Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Font Size=-1>
<Tr><Td><b>double_scalar_w</b></Td>
<Td><Center><Font Size=-1>DEV_DOUBLE</Font></Center></Td><Td><Center><Font Size=-1>WRITE</Font></Center></Td><Td><Center> - </Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Font Size=-1>
<Tr><Td><b>double_scalar_rww</b></Td>
<Td><Center><Font Size=-1>DEV_DOUBLE</Font></Center></Td><Td><Center><Font Size=-1>READ_WITH_WRITE</Font></Center></Td><Td><Center><Font Size=-1>double_scalar_w</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Font Size=-1>
<Tr><Td><b>string_scalar</b></Td>
<Td><Center><Font Size=-1>DEV_STRING</Font></Center></Td><Td><Center><Font Size=-1>READ_WRITE</Font></Center></Td><Td><Center> - </Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Font Size=-1>
<Tr><Td><b>boolean_scalar</b>: <Font Size=-1>A boolean scalar attribute</Font></Td>
<Td><Center><Font Size=-1>DEV_BOOLEAN</Font></Center></Td><Td><Center><Font Size=-1>READ_WRITE</Font></Center></Td><Td><Center> - </Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Font Size=-1>
<Tr><Td><b>float_scalar</b>: <Font Size=-1>A float attribute</Font></Td>
<Td><Center><Font Size=-1>DEV_FLOAT</Font></Center></Td><Td><Center><Font Size=-1>READ_WRITE</Font></Center></Td><Td><Center> - </Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Font Size=-1>
<Tr><Td><b>uchar_scalar</b></Td>
<Td><Center><Font Size=-1>DEV_UCHAR</Font></Center></Td><Td><Center><Font Size=-1>READ_WRITE</Font></Center></Td><Td><Center> - </Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Font Size=-1>
<Tr><Td><b>ushort_scalar</b></Td>
<Td><Center><Font Size=-1>DEV_USHORT</Font></Center></Td><Td><Center><Font Size=-1>READ_WRITE</Font></Center></Td><Td><Center> - </Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Font Size=-1>
<Tr><Td><b>ampli</b></Td>
<Td><Center><Font Size=-1>DEV_DOUBLE</Font></Center></Td><Td><Center><Font Size=-1>WRITE</Font></Center></Td><Td><Center> - </Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Font Size=-1>
<Tr><Td><b>no_value</b></Td>
<Td><Center><Font Size=-1>DEV_LONG</Font></Center></Td><Td><Center><Font Size=-1>READ</Font></Center></Td><Td><Center> - </Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Font Size=-1>
<Tr><Td><b>throw_exception</b></Td>
<Td><Center><Font Size=-1>DEV_LONG</Font></Center></Td><Td><Center><Font Size=-1>READ</Font></Center></Td><Td><Center> - </Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

</Table>
</Center>
<Br><Br><Br><Br><Br>
<Table Border=2 Cellpadding=3 CELLSPACING=0 WIDTH="100%">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<Td COLSPAN=4> <Font Size=+2><Center><b>Spectrum Attributes</b></td></Font></Center>
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<Td><Center><b>Attribute name</b></td></Center>
<Td><Center><b>Data Type</b></td></Center>
<Td><Center><b>X Data Length</b></td></Center>
<Td><Center><b>Expert</b></td></Center>
<Tr><Td><b>short_spectrum</b></Td>
<Td><Center><Font Size=-1>DEV_SHORT</Font></Center></Td><Td><Center><Font Size=-1>4096</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>long_spectrum</b></Td>
<Td><Center><Font Size=-1>DEV_LONG</Font></Center></Td><Td><Center><Font Size=-1>4096</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>double_spectrum</b></Td>
<Td><Center><Font Size=-1>DEV_DOUBLE</Font></Center></Td><Td><Center><Font Size=-1>4096</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>boolean_spectrum</b></Td>
<Td><Center><Font Size=-1>DEV_BOOLEAN</Font></Center></Td><Td><Center><Font Size=-1>4096</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>uchar_spectrum</b>: <Font Size=-1>An unsigned char spectrum attribute</Font></Td>
<Td><Center><Font Size=-1>DEV_UCHAR</Font></Center></Td><Td><Center><Font Size=-1>4096</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>ushort_spectrum</b>: <Font Size=-1>An unsigned short spectrum attribute</Font></Td>
<Td><Center><Font Size=-1>DEV_USHORT</Font></Center></Td><Td><Center><Font Size=-1>4096</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>float_spectrum</b>: <Font Size=-1>A float spectrum attribute</Font></Td>
<Td><Center><Font Size=-1>DEV_FLOAT</Font></Center></Td><Td><Center><Font Size=-1>4096</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>wave</b></Td>
<Td><Center><Font Size=-1>DEV_DOUBLE</Font></Center></Td><Td><Center><Font Size=-1>4096</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>short_spectrum_ro</b></Td>
<Td><Center><Font Size=-1>DEV_SHORT</Font></Center></Td><Td><Center><Font Size=-1>4096</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>float_spectrum_ro</b></Td>
<Td><Center><Font Size=-1>DEV_FLOAT</Font></Center></Td><Td><Center><Font Size=-1>4096</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>long_spectrum_ro</b></Td>
<Td><Center><Font Size=-1>DEV_LONG</Font></Center></Td><Td><Center><Font Size=-1>4096</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>double_spectrum_ro</b></Td>
<Td><Center><Font Size=-1>DEV_DOUBLE</Font></Center></Td><Td><Center><Font Size=-1>4096</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>boolean_spectrum_ro</b></Td>
<Td><Center><Font Size=-1>DEV_BOOLEAN</Font></Center></Td><Td><Center><Font Size=-1>4096</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>uchar_spectrum_ro</b></Td>
<Td><Center><Font Size=-1>DEV_UCHAR</Font></Center></Td><Td><Center><Font Size=-1>4096</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>ushort_spectrum_ro</b></Td>
<Td><Center><Font Size=-1>DEV_USHORT</Font></Center></Td><Td><Center><Font Size=-1>4096</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>string_spectrum</b></Td>
<Td><Center><Font Size=-1>DEV_STRING</Font></Center></Td><Td><Center><Font Size=-1>256</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>string_spectrum_ro</b></Td>
<Td><Center><Font Size=-1>DEV_STRING</Font></Center></Td><Td><Center><Font Size=-1>256</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

</Table>
</Center>
<Br><Br><Br><Br><Br>
<Table Border=2 Cellpadding=3 CELLSPACING=0 WIDTH="100%">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<Td COLSPAN=5> <Font Size=+2><Center><b>Image Attributes</b></td></Font></Center>
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<Td><Center><b>Attribute name</b></td></Center>
<Td><Center><b>Data Type</b></td></Center>
<Td><Center><b>X Data Length</b></td></Center>
<Td><Center><b>Y Data Length</b></td></Center>
<Td><Center><b>Expert</b></td></Center>
<Tr><Td><b>uchar_image_ro</b>: <Font Size=-1>An unsigned char image attribute</Font></Td>
<Td><Center><Font Size=-1>DEV_UCHAR</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>ushort_image_ro</b>: <Font Size=-1>An unsigned short image attribute</Font></Td>
<Td><Center><Font Size=-1>DEV_USHORT</Font></Center></Td><Td><Center><Font Size=-1>8192</Font></Center></Td><Td><Center><Font Size=-1>8192</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>float_image_ro</b>: <Font Size=-1>A float image attribute</Font></Td>
<Td><Center><Font Size=-1>DEV_FLOAT</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>short_image_ro</b></Td>
<Td><Center><Font Size=-1>DEV_SHORT</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>long_image_ro</b></Td>
<Td><Center><Font Size=-1>DEV_LONG</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>double_image_ro</b></Td>
<Td><Center><Font Size=-1>DEV_DOUBLE</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>boolean_image_ro</b></Td>
<Td><Center><Font Size=-1>DEV_BOOLEAN</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>boolean_image</b></Td>
<Td><Center><Font Size=-1>DEV_BOOLEAN</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>uchar_image</b></Td>
<Td><Center><Font Size=-1>DEV_UCHAR</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>short_image</b></Td>
<Td><Center><Font Size=-1>DEV_SHORT</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>ushort_image</b></Td>
<Td><Center><Font Size=-1>DEV_USHORT</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>long_image</b></Td>
<Td><Center><Font Size=-1>DEV_LONG</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>float_image</b></Td>
<Td><Center><Font Size=-1>DEV_FLOAT</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>double_image</b></Td>
<Td><Center><Font Size=-1>DEV_DOUBLE</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>251</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>string_image</b></Td>
<Td><Center><Font Size=-1>DEV_STRING</Font></Center></Td><Td><Center><Font Size=-1>256</Font></Center></Td><Td><Center><Font Size=-1>256</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

<Tr><Td><b>string_image_ro</b></Td>
<Td><Center><Font Size=-1>DEV_STRING</Font></Center></Td><Td><Center><Font Size=-1>256</Font></Center></Td><Td><Center><Font Size=-1>256</Font></Center></Td><Td><Center><Font Size=-1>No</Font></Center></Td></Tr>

</Table>
</Center>

<Center>
<Br>
<HR WIDTH="100%"></H5>
<H3> ESRF - Software Engineering Group </H3>
</Center>
</body>
</html>
